#pragma once
/* this file was auto-generated from ./src/modules/flow/regexp/regexp.json */
#include <stdbool.h>
#include <stdint.h>
#include <sol-flow.h>


#ifdef __cplusplus
extern "C" {
#endif

#define SOL_FLOW_NODE_TYPE_REGEXP_SEARCH_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_REGEXP_SEARCH;

struct sol_flow_node_type_regexp_search_options {
    struct sol_flow_node_options base;
#define SOL_FLOW_NODE_TYPE_REGEXP_SEARCH_OPTIONS_API_VERSION (1)
    int32_t index; /**< This value defines which substring match (by index, starting from 0) inside the one that was fed to the 'IN' port should be output in the 'OUT' port. It must be non-negative. It can be overriden by values received on 'INDEX' port. (default: 0) */
    int32_t max_regexp_search; /**< The regular expression matching against the input string can result in various substring matches. This value defines the maximum number of them to generate and make available for selection by the 'INDEX' port. This option can be overriden by values received on the 'MAX_REGEXP_SEARCH' port. The value of zero (default one) will be interpreted as to generate all possible matches. (default: 0) */
    const char * regexp; /**< Regular expression pattern to search the string received on 'IN' port with. It can be overriden by values received on 'REGEXP' port. (required) */
};

#define SOL_FLOW_NODE_TYPE_REGEXP_SEARCH_OPTIONS_DEFAULTS(...) { \
    .base = { \
        SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_OPTIONS_API_VERSION, ) \
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_REGEXP_SEARCH_OPTIONS_API_VERSION) \
    }, \
    .index = 0, \
    .max_regexp_search = 0, \
    __VA_ARGS__ \
}
/* Input Ports */
#define SOL_FLOW_NODE_TYPE_REGEXP_SEARCH__IN__IN (0)
#define SOL_FLOW_NODE_TYPE_REGEXP_SEARCH__IN__REGEXP (1)
#define SOL_FLOW_NODE_TYPE_REGEXP_SEARCH__IN__INDEX (2)
#define SOL_FLOW_NODE_TYPE_REGEXP_SEARCH__IN__MAX_REGEXP_SEARCH (3)
#define SOL_FLOW_NODE_TYPE_REGEXP_SEARCH__IN_LAST (3)

/* Output Ports */
#define SOL_FLOW_NODE_TYPE_REGEXP_SEARCH__OUT__LENGTH (0)
#define SOL_FLOW_NODE_TYPE_REGEXP_SEARCH__OUT__OUT (1)
#define SOL_FLOW_NODE_TYPE_REGEXP_SEARCH__OUT_LAST (1)

#define SOL_FLOW_NODE_TYPE_REGEXP_REPLACE_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_REGEXP_REPLACE;

struct sol_flow_node_type_regexp_replace_options {
    struct sol_flow_node_options base;
#define SOL_FLOW_NODE_TYPE_REGEXP_REPLACE_OPTIONS_API_VERSION (1)
    int32_t max_regexp_replace; /**< The regular expression matching against the input string can result in various substring matches. This value defines the maximum number of them to replace for the string given in the 'to' option. This option can be overriden by values received on the 'MAX_REGEXP_REPLACE' port. The value of zero (default one) will be interpreted as to replace all possible matches. (default: 0) */
    const char * regexp; /**< Regular expression pattern to match the string received on 'IN' port with. If groups are used, they may be referred back on the string coming in the 'TO' port. It must not be an empty string. It may be overriden by values received on 'REGEXP' port. (required) */
    const char * to; /**< String substitution for the pattern match. Groups present on the string provided to the port 'REGEXP' may be referred here on the substitution (e.g. \\g1 or \\1 for the first matching group). It may be an empty string. It can be overriden by values received on 'TO' port. (required) */
    bool forward_on_no_match; /**< Whether to only forward the input string as is to the output port when no matches occur (true) or to generate error packets (false) (default: True) */
};

#define SOL_FLOW_NODE_TYPE_REGEXP_REPLACE_OPTIONS_DEFAULTS(...) { \
    .base = { \
        SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_OPTIONS_API_VERSION, ) \
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_REGEXP_REPLACE_OPTIONS_API_VERSION) \
    }, \
    .max_regexp_replace = 0, \
    .forward_on_no_match = true, \
    __VA_ARGS__ \
}
/* Input Ports */
#define SOL_FLOW_NODE_TYPE_REGEXP_REPLACE__IN__IN (0)
#define SOL_FLOW_NODE_TYPE_REGEXP_REPLACE__IN__REGEXP (1)
#define SOL_FLOW_NODE_TYPE_REGEXP_REPLACE__IN__TO (2)
#define SOL_FLOW_NODE_TYPE_REGEXP_REPLACE__IN__MAX_REGEXP_REPLACE (3)
#define SOL_FLOW_NODE_TYPE_REGEXP_REPLACE__IN_LAST (3)

/* Output Ports */
#define SOL_FLOW_NODE_TYPE_REGEXP_REPLACE__OUT__OUT (0)
#define SOL_FLOW_NODE_TYPE_REGEXP_REPLACE__OUT_LAST (0)

#ifndef SOL_LOG_DOMAIN
#define SOL_LOG_DOMAIN &_log_domain
#include "sol-log.h"

#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_DECLARE(_var, _name)     SOL_ATTR_UNUSED struct sol_log_domain _var = {         .name = "sol-" _name,         .color = SOL_LOG_COLOR_MAGENTA,         .level = SOL_LOG_LEVEL_WARNING     }

#define SOL_LOG_INTERNAL_DECLARE_STATIC(_var, _name)     static SOL_LOG_INTERNAL_DECLARE(_var, _name)

SOL_LOG_INTERNAL_DECLARE_STATIC(_log_domain, "flow-regexp");

#else // #ifdef SOL_LOG_ENABLED

#define SOL_LOG_INTERNAL_DECLARE(_var, _name)
#define SOL_LOG_INTERNAL_DECLARE_STATIC(_var, _name)

#ifdef SOL_LOG_DOMAIN
#undef SOL_LOG_DOMAIN
#define SOL_LOG_DOMAIN NULL
#endif // #ifdef SOL_LOG_DOMAIN

#endif // #ifdef SOL_LOG_ENABLED
#endif // ifndef SOL_LOG_DOMAIN

#ifdef __cplusplus
}
#endif
